diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/file.php ./wordpress-3.4/wp-admin/includes/file.php
*** ./wordpress-3.3.2/wp-admin/includes/file.php	2011-11-08 16:34:09.000000000 -0600
--- ./wordpress-3.4/wp-admin/includes/file.php	2012-03-28 22:00:38.000000000 -0500
***************
*** 65,71 ****
  			return sprintf( __( '%s Page Template' ), _cleanup_header_comment($name[1]) );
  	}
  
! 	return basename( $file );
  }
  
  /**
--- 65,71 ----
  			return sprintf( __( '%s Page Template' ), _cleanup_header_comment($name[1]) );
  	}
  
! 	return trim( basename( $file ) );
  }
  
  /**
***************
*** 81,87 ****
  	$siteurl = get_option( 'siteurl' );
  	if ( $home != '' && $home != $siteurl ) {
  		$wp_path_rel_to_home = str_replace($home, '', $siteurl); /* $siteurl - $home */
! 		$pos = strpos($_SERVER["SCRIPT_FILENAME"], $wp_path_rel_to_home);
  		$home_path = substr($_SERVER["SCRIPT_FILENAME"], 0, $pos);
  		$home_path = trailingslashit( $home_path );
  	} else {
--- 81,87 ----
  	$siteurl = get_option( 'siteurl' );
  	if ( $home != '' && $home != $siteurl ) {
  		$wp_path_rel_to_home = str_replace($home, '', $siteurl); /* $siteurl - $home */
! 		$pos = strrpos($_SERVER["SCRIPT_FILENAME"], $wp_path_rel_to_home);
  		$home_path = substr($_SERVER["SCRIPT_FILENAME"], 0, $pos);
  		$home_path = trailingslashit( $home_path );
  	} else {
***************
*** 157,163 ****
   * Please note that the calling function must unlink() this itself.
   *
   * The filename is based off the passed parameter or defaults to the current unix timestamp,
!  * while the directory can either be passed as well, or by leaving  it blank, default to a writable temporary directory.
   *
   * @since 2.6.0
   *
--- 157,163 ----
   * Please note that the calling function must unlink() this itself.
   *
   * The filename is based off the passed parameter or defaults to the current unix timestamp,
!  * while the directory can either be passed as well, or by leaving it blank, default to a writable temporary directory.
   *
   * @since 2.6.0
   *
***************
*** 240,246 ****
  	// You may define your own function and pass the name in $overrides['upload_error_handler']
  	$upload_error_handler = 'wp_handle_upload_error';
  
! 	// You may have had one or more 'wp_handle_upload_prefilter' functions error out the file.  Handle that gracefully.
  	if ( isset( $file['error'] ) && !is_numeric( $file['error'] ) && $file['error'] )
  		return $upload_error_handler( $file, $file['error'] );
  
--- 240,246 ----
  	// You may define your own function and pass the name in $overrides['upload_error_handler']
  	$upload_error_handler = 'wp_handle_upload_error';
  
! 	// You may have had one or more 'wp_handle_upload_prefilter' functions error out the file. Handle that gracefully.
  	if ( isset( $file['error'] ) && !is_numeric( $file['error'] ) && $file['error'] )
  		return $upload_error_handler( $file, $file['error'] );
  
***************
*** 323,352 ****
  
  	$filename = wp_unique_filename( $uploads['path'], $file['name'], $unique_filename_callback );
  
- 	$tmp_file = wp_tempnam($filename);
- 
  	// Move the file to the uploads dir
- 	if ( false === @ move_uploaded_file( $file['tmp_name'], $tmp_file ) )
- 		return $upload_error_handler( $file, sprintf( __('The uploaded file could not be moved to %s.' ), $uploads['path'] ) );
- 
- 	// If a resize was requested, perform the resize.
- 	$image_resize = isset( $_POST['image_resize'] ) && 'true' == $_POST['image_resize'];
- 	$do_resize = apply_filters( 'wp_upload_resize', $image_resize );
- 	$size = @getimagesize( $tmp_file );
- 	if ( $do_resize && $size ) {
- 		$old_temp = $tmp_file;
- 		$tmp_file = image_resize( $tmp_file, (int) get_option('large_size_w'), (int) get_option('large_size_h'), 0, 'resized');
- 		if ( ! is_wp_error($tmp_file) ) {
- 			unlink($old_temp);
- 		} else {
- 			$tmp_file = $old_temp;
- 		}
- 	}
- 
- 	// Copy the temporary file into its destination
  	$new_file = $uploads['path'] . "/$filename";
! 	copy( $tmp_file, $new_file );
! 	unlink($tmp_file);
  
  	// Set correct file permissions
  	$stat = stat( dirname( $new_file ));
--- 323,332 ----
  
  	$filename = wp_unique_filename( $uploads['path'], $file['name'], $unique_filename_callback );
  
  	// Move the file to the uploads dir
  	$new_file = $uploads['path'] . "/$filename";
! 	if ( false === @ move_uploaded_file( $file['tmp_name'], $new_file ) )
! 		return $upload_error_handler( $file, sprintf( __('The uploaded file could not be moved to %s.' ), $uploads['path'] ) );
  
  	// Set correct file permissions
  	$stat = stat( dirname( $new_file ));
***************
*** 364,370 ****
  
  /**
   * Handle sideloads, which is the process of retrieving a media item from another server instead of
!  * a traditional media upload.  This process involves sanitizing the filename, checking extensions
   * for mime type, and moving the file to the appropriate directory within the uploads directory.
   *
   * @since 2.6.0
--- 344,350 ----
  
  /**
   * Handle sideloads, which is the process of retrieving a media item from another server instead of
!  * a traditional media upload. This process involves sanitizing the filename, checking extensions
   * for mime type, and moving the file to the appropriate directory within the uploads directory.
   *
   * @since 2.6.0
***************
*** 486,492 ****
  
  /**
   * Downloads a url to a local temporary file using the WordPress HTTP Class.
!  * Please note, That the calling function must unlink() the  file.
   *
   * @since 2.5.0
   *
--- 466,472 ----
  
  /**
   * Downloads a url to a local temporary file using the WordPress HTTP Class.
!  * Please note, That the calling function must unlink() the file.
   *
   * @since 2.5.0
   *
***************
*** 648,654 ****
  			return new WP_Error('extract_failed', __('Could not extract file from archive.'), $info['name']);
  
  		if ( ! $wp_filesystem->put_contents( $to . $info['name'], $contents, FS_CHMOD_FILE) )
! 			return new WP_Error('copy_failed', __('Could not copy file.'), $to . $info['filename']);
  	}
  
  	$z->close();
--- 628,634 ----
  			return new WP_Error('extract_failed', __('Could not extract file from archive.'), $info['name']);
  
  		if ( ! $wp_filesystem->put_contents( $to . $info['name'], $contents, FS_CHMOD_FILE) )
! 			return new WP_Error('copy_failed', __('Could not copy file.'), $to . $info['name']);
  	}
  
  	$z->close();
***************
*** 884,890 ****
  }
  
  /**
!  * Displays a form to the user to request for their FTP/SSH details in order to  connect to the filesystem.
   * All chosen/entered details are saved, Excluding the Password.
   *
   * Hostnames may be in the form of hostname:portnumber (eg: wordpress.org:2467) to specify an alternate FTP/SSH port.
--- 864,870 ----
  }
  
  /**
!  * Displays a form to the user to request for their FTP/SSH details in order to connect to the filesystem.
   * All chosen/entered details are saved, Excluding the Password.
   *
   * Hostnames may be in the form of hostname:portnumber (eg: wordpress.org:2467) to specify an alternate FTP/SSH port.
***************
*** 896,902 ****
   * @param string $form_post the URL to post the form to
   * @param string $type the chosen Filesystem method in use
   * @param boolean $error if the current request has failed to connect
!  * @param string $context The directory which is needed access to, The write-test will be performed on  this directory by get_filesystem_method()
   * @param string $extra_fields Extra POST fields which should be checked for to be included in the post.
   * @return boolean False on failure. True on success.
   */
--- 876,882 ----
   * @param string $form_post the URL to post the form to
   * @param string $type the chosen Filesystem method in use
   * @param boolean $error if the current request has failed to connect
!  * @param string $context The directory which is needed access to, The write-test will be performed on this directory by get_filesystem_method()
   * @param string $extra_fields Extra POST fields which should be checked for to be included in the post.
   * @return boolean False on failure. True on success.
   */
***************
*** 1075,1079 ****
  <?php
  	return false;
  }
- 
- ?>
--- 1055,1057 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/image-edit.php ./wordpress-3.4/wp-admin/includes/image-edit.php
*** ./wordpress-3.3.2/wp-admin/includes/image-edit.php	2011-10-18 15:33:34.000000000 -0500
--- ./wordpress-3.4/wp-admin/includes/image-edit.php	2012-04-06 15:47:24.000000000 -0500
***************
*** 67,73 ****
  	<input type="hidden" id="imgedit-y-<?php echo $post_id; ?>" value="<?php echo $meta['height']; ?>" />
  
  	<div id="imgedit-crop-<?php echo $post_id; ?>" class="imgedit-crop-wrap">
! 	<img id="image-preview-<?php echo $post_id; ?>" onload="imageEdit.imgLoaded('<?php echo $post_id; ?>')" src="<?php echo admin_url('admin-ajax.php'); ?>?action=imgedit-preview&amp;_ajax_nonce=<?php echo $nonce; ?>&amp;postid=<?php echo $post_id; ?>&amp;rand=<?php echo rand(1, 99999); ?>" />
  	</div>
  
  	<div class="imgedit-submit">
--- 67,73 ----
  	<input type="hidden" id="imgedit-y-<?php echo $post_id; ?>" value="<?php echo $meta['height']; ?>" />
  
  	<div id="imgedit-crop-<?php echo $post_id; ?>" class="imgedit-crop-wrap">
! 	<img id="image-preview-<?php echo $post_id; ?>" onload="imageEdit.imgLoaded('<?php echo $post_id; ?>')" src="<?php echo admin_url( 'admin-ajax.php', 'relative' ); ?>?action=imgedit-preview&amp;_ajax_nonce=<?php echo $nonce; ?>&amp;postid=<?php echo $post_id; ?>&amp;rand=<?php echo rand(1, 99999); ?>" />
  	</div>
  
  	<div class="imgedit-submit">
***************
*** 192,241 ****
  	</tbody></table>
  	<div class="imgedit-wait" id="imgedit-wait-<?php echo $post_id; ?>"></div>
  	<script type="text/javascript">imageEdit.init(<?php echo $post_id; ?>);</script>
! 	<div class="hidden" id="imgedit-leaving-<?php echo $post_id; ?>"><?php _e("There are unsaved changes that will be lost.  'OK' to continue, 'Cancel' to return to the Image Editor."); ?></div>
  	</div>
  <?php
  }
  
- function load_image_to_edit($post_id, $mime_type, $size = 'full') {
- 	$filepath = get_attached_file($post_id);
- 
- 	if ( $filepath && file_exists($filepath) ) {
- 		if ( 'full' != $size && ( $data = image_get_intermediate_size($post_id, $size) ) ) {
- 			$filepath = apply_filters('load_image_to_edit_filesystempath', path_join( dirname($filepath), $data['file'] ), $post_id, $size);
- 		}
- 	} elseif ( function_exists('fopen') && function_exists('ini_get') && true == ini_get('allow_url_fopen') ) {
- 		$filepath = apply_filters('load_image_to_edit_attachmenturl', wp_get_attachment_url($post_id) , $post_id, $size);
- 	}
- 
- 	$filepath = apply_filters('load_image_to_edit_path', $filepath, $post_id, $size);
- 	if ( empty($filepath) )
- 		return false;
- 
- 	switch ( $mime_type ) {
- 		case 'image/jpeg':
- 			$image = imagecreatefromjpeg($filepath);
- 			break;
- 		case 'image/png':
- 			$image = imagecreatefrompng($filepath);
- 			break;
- 		case 'image/gif':
- 			$image = imagecreatefromgif($filepath);
- 			break;
- 		default:
- 			$image = false;
- 			break;
- 	}
- 	if ( is_resource($image) ) {
- 		$image = apply_filters('load_image_to_edit', $image, $post_id, $size);
- 		if ( function_exists('imagealphablending') && function_exists('imagesavealpha') ) {
- 			imagealphablending($image, false);
- 			imagesavealpha($image, true);
- 		}
- 	}
- 	return $image;
- }
- 
  function wp_stream_image($image, $mime_type, $post_id) {
  	$image = apply_filters('image_save_pre', $image, $post_id);
  
--- 192,202 ----
  	</tbody></table>
  	<div class="imgedit-wait" id="imgedit-wait-<?php echo $post_id; ?>"></div>
  	<script type="text/javascript">imageEdit.init(<?php echo $post_id; ?>);</script>
! 	<div class="hidden" id="imgedit-leaving-<?php echo $post_id; ?>"><?php _e("There are unsaved changes that will be lost. 'OK' to continue, 'Cancel' to return to the Image Editor."); ?></div>
  	</div>
  <?php
  }
  
  function wp_stream_image($image, $mime_type, $post_id) {
  	$image = apply_filters('image_save_pre', $image, $post_id);
  
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/image.php ./wordpress-3.4/wp-admin/includes/image.php
*** ./wordpress-3.3.2/wp-admin/includes/image.php	2011-09-03 09:18:10.000000000 -0500
--- ./wordpress-3.4/wp-admin/includes/image.php	2012-06-09 20:26:12.000000000 -0500
***************
*** 32,38 ****
   *
   * @since 2.1.0
   *
!  * @param string|int $src_file The source file or Attachment ID.
   * @param int $src_x The start x position to crop from.
   * @param int $src_y The start y position to crop from.
   * @param int $src_w The width to crop.
--- 32,38 ----
   *
   * @since 2.1.0
   *
!  * @param string|int $src The source file or Attachment ID.
   * @param int $src_x The start x position to crop from.
   * @param int $src_y The start y position to crop from.
   * @param int $src_w The width to crop.
***************
*** 43,55 ****
   * @param string $dst_file Optional. The destination file to write to.
   * @return string|WP_Error|false New filepath on success, WP_Error or false on failure.
   */
! function wp_crop_image( $src_file, $src_x, $src_y, $src_w, $src_h, $dst_w, $dst_h, $src_abs = false, $dst_file = false ) {
! 	if ( is_numeric( $src_file ) ) // Handle int as attachment ID
! 		$src_file = get_attached_file( $src_file );
! 
! 	$src = wp_load_image( $src_file );
  
! 	if ( !is_resource( $src ) )
  		return new WP_Error( 'error_loading_image', $src, $src_file );
  
  	$dst = wp_imagecreatetruecolor( $dst_w, $dst_h );
--- 43,69 ----
   * @param string $dst_file Optional. The destination file to write to.
   * @return string|WP_Error|false New filepath on success, WP_Error or false on failure.
   */
! function wp_crop_image( $src, $src_x, $src_y, $src_w, $src_h, $dst_w, $dst_h, $src_abs = false, $dst_file = false ) {
! 	if ( is_numeric( $src ) ) { // Handle int as attachment ID
! 		$src_file = get_attached_file( $src );
! 		if ( ! file_exists( $src_file ) ) {
! 			// If the file doesn't exist, attempt a url fopen on the src link.
! 			// This can occur with certain file replication plugins.
! 			$post = get_post( $src );
! 			$image_type = $post->post_mime_type;
! 			$src = load_image_to_edit( $src, $post->post_mime_type, 'full' );
! 		} else {
! 			$size = @getimagesize( $src_file );
! 			$image_type = ( $size ) ? $size['mime'] : '';
! 			$src = wp_load_image( $src_file );
! 		}
! 	} else {
! 		$size = @getimagesize( $src );
! 		$image_type = ( $size ) ? $size['mime'] : '';
! 		$src = wp_load_image( $src );
! 	}
  
! 	if ( ! is_resource( $src ) )
  		return new WP_Error( 'error_loading_image', $src, $src_file );
  
  	$dst = wp_imagecreatetruecolor( $dst_w, $dst_h );
***************
*** 59,65 ****
  		$src_h -= $src_y;
  	}
  
! 	if (function_exists('imageantialias'))
  		imageantialias( $dst, true );
  
  	imagecopyresampled( $dst, $src, 0, 0, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h );
--- 73,79 ----
  		$src_h -= $src_y;
  	}
  
! 	if ( function_exists( 'imageantialias' ) )
  		imageantialias( $dst, true );
  
  	imagecopyresampled( $dst, $src, 0, 0, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h );
***************
*** 69,77 ****
  	if ( ! $dst_file )
  		$dst_file = str_replace( basename( $src_file ), 'cropped-' . basename( $src_file ), $src_file );
  
! 	$dst_file = preg_replace( '/\\.[^\\.]+$/', '.jpg', $dst_file );
  
! 	if ( imagejpeg( $dst, $dst_file, apply_filters( 'jpeg_quality', 90, 'wp_crop_image' ) ) )
  		return $dst_file;
  	else
  		return false;
--- 83,100 ----
  	if ( ! $dst_file )
  		$dst_file = str_replace( basename( $src_file ), 'cropped-' . basename( $src_file ), $src_file );
  
! 	if ( 'image/png' != $image_type )
! 		$dst_file = preg_replace( '/\\.[^\\.]+$/', '.jpg', $dst_file );
! 
! 	// The directory containing the original file may no longer exist when
! 	// using a replication plugin.
! 	wp_mkdir_p( dirname( $dst_file ) );
! 
! 	$dst_file = dirname( $dst_file ) . '/' . wp_unique_filename( dirname( $dst_file ), basename( $dst_file ) );
  
! 	if ( 'image/png' == $image_type && imagepng( $dst, $dst_file ) )
! 		return $dst_file;
! 	elseif ( imagejpeg( $dst, $dst_file, apply_filters( 'jpeg_quality', 90, 'wp_crop_image' ) ) )
  		return $dst_file;
  	else
  		return false;
***************
*** 104,110 ****
  		global $_wp_additional_image_sizes;
  
  		foreach ( get_intermediate_image_sizes() as $s ) {
! 			$sizes[$s] = array( 'width' => '', 'height' => '', 'crop' => FALSE );
  			if ( isset( $_wp_additional_image_sizes[$s]['width'] ) )
  				$sizes[$s]['width'] = intval( $_wp_additional_image_sizes[$s]['width'] ); // For theme-added sizes
  			else
--- 127,133 ----
  		global $_wp_additional_image_sizes;
  
  		foreach ( get_intermediate_image_sizes() as $s ) {
! 			$sizes[$s] = array( 'width' => '', 'height' => '', 'crop' => false );
  			if ( isset( $_wp_additional_image_sizes[$s]['width'] ) )
  				$sizes[$s]['width'] = intval( $_wp_additional_image_sizes[$s]['width'] ); // For theme-added sizes
  			else
***************
*** 205,211 ****
  
  	// exif contains a bunch of data we'll probably never need formatted in ways
  	// that are difficult to use. We'll normalize it and just extract the fields
! 	// that are likely to be useful.  Fractions and numbers are converted to
  	// floats, dates to unix timestamps, and everything else to strings.
  	$meta = array(
  		'aperture' => 0,
--- 228,234 ----
  
  	// exif contains a bunch of data we'll probably never need formatted in ways
  	// that are difficult to use. We'll normalize it and just extract the fields
! 	// that are likely to be useful. Fractions and numbers are converted to
  	// floats, dates to unix timestamps, and everything else to strings.
  	$meta = array(
  		'aperture' => 0,
***************
*** 296,303 ****
  			$meta['created_timestamp'] = wp_exif_date2ts($exif['DateTimeDigitized'] );
  		if ( ! empty($exif['FocalLength'] ) )
  			$meta['focal_length'] = wp_exif_frac2dec( $exif['FocalLength'] );
! 		if ( ! empty($exif['ISOSpeedRatings'] ) )
! 			$meta['iso'] = utf8_encode( trim( $exif['ISOSpeedRatings'] ) );
  		if ( ! empty($exif['ExposureTime'] ) )
  			$meta['shutter_speed'] = wp_exif_frac2dec( $exif['ExposureTime'] );
  	}
--- 319,328 ----
  			$meta['created_timestamp'] = wp_exif_date2ts($exif['DateTimeDigitized'] );
  		if ( ! empty($exif['FocalLength'] ) )
  			$meta['focal_length'] = wp_exif_frac2dec( $exif['FocalLength'] );
! 		if ( ! empty($exif['ISOSpeedRatings'] ) ) {
! 			$meta['iso'] = is_array( $exif['ISOSpeedRatings'] ) ? reset( $exif['ISOSpeedRatings'] ) : $exif['ISOSpeedRatings'];
! 			$meta['iso'] = utf8_encode( trim( $meta['iso'] ) );
! 		}
  		if ( ! empty($exif['ExposureTime'] ) )
  			$meta['shutter_speed'] = wp_exif_frac2dec( $exif['ExposureTime'] );
  	}
***************
*** 339,341 ****
--- 364,463 ----
  
  	return apply_filters('file_is_displayable_image', $result, $path);
  }
+ 
+ /**
+  * Load an image resource for editing.
+  *
+  * @since 2.9.0
+  *
+  * @param string $attachment_id Attachment ID.
+  * @param string $mime_type Image mime type.
+  * @param string $size Optional. Image size, defaults to 'full'.
+  * @return resource|false The resulting image resource on success, false on failure.
+  */
+ function load_image_to_edit( $attachment_id, $mime_type, $size = 'full' ) {
+ 	$filepath = _load_image_to_edit_path( $attachment_id, $size );
+ 	if ( empty( $filepath ) )
+ 		return false;
+ 
+ 	switch ( $mime_type ) {
+ 		case 'image/jpeg':
+ 			$image = imagecreatefromjpeg($filepath);
+ 			break;
+ 		case 'image/png':
+ 			$image = imagecreatefrompng($filepath);
+ 			break;
+ 		case 'image/gif':
+ 			$image = imagecreatefromgif($filepath);
+ 			break;
+ 		default:
+ 			$image = false;
+ 			break;
+ 	}
+ 	if ( is_resource($image) ) {
+ 		$image = apply_filters('load_image_to_edit', $image, $attachment_id, $size);
+ 		if ( function_exists('imagealphablending') && function_exists('imagesavealpha') ) {
+ 			imagealphablending($image, false);
+ 			imagesavealpha($image, true);
+ 		}
+ 	}
+ 	return $image;
+ }
+ 
+ /**
+  * Retrieve the path or url of an attachment's attached file.
+  *
+  * If the attached file is not present on the local filesystem (usually due to replication plugins),
+  * then the url of the file is returned if url fopen is supported.
+  *
+  * @since 3.4.0
+  * @access private
+  *
+  * @param string $attachment_id Attachment ID.
+  * @param string $size Optional. Image size, defaults to 'full'.
+  * @return string|false File path or url on success, false on failure.
+  */
+ function _load_image_to_edit_path( $attachment_id, $size = 'full' ) {
+ 	$filepath = get_attached_file( $attachment_id );
+ 
+ 	if ( $filepath && file_exists( $filepath ) ) {
+ 		if ( 'full' != $size && ( $data = image_get_intermediate_size( $attachment_id, $size ) ) ) {
+ 			$filepath = apply_filters( 'load_image_to_edit_filesystempath', path_join( dirname( $filepath ), $data['file'] ), $attachment_id, $size );
+ 		}
+ 	} elseif ( function_exists( 'fopen' ) && function_exists( 'ini_get' ) && true == ini_get( 'allow_url_fopen' ) ) {
+ 		$filepath = apply_filters( 'load_image_to_edit_attachmenturl', wp_get_attachment_url( $attachment_id ), $attachment_id, $size );
+ 	}
+ 
+ 	return apply_filters( 'load_image_to_edit_path', $filepath, $attachment_id, $size );
+ }
+ 
+ /**
+  * Copy an existing image file.
+  *
+  * @since 3.4.0
+  * @access private
+  *
+  * @param string $attachment_id Attachment ID.
+  * @return string|false New file path on success, false on failure.
+  */
+ function _copy_image_file( $attachment_id ) {
+ 	$dst_file = $src_file = get_attached_file( $attachment_id );
+ 	if ( ! file_exists( $src_file ) )
+ 		$src_file = _load_image_to_edit_path( $attachment_id );
+ 
+ 	if ( $src_file ) {
+ 		$dst_file = str_replace( basename( $dst_file ), 'copy-' . basename( $dst_file ), $dst_file );
+ 		$dst_file = dirname( $dst_file ) . '/' . wp_unique_filename( dirname( $dst_file ), basename( $dst_file ) );
+ 
+ 		// The directory containing the original file may no longer exist when
+ 		// using a replication plugin.
+ 		wp_mkdir_p( dirname( $dst_file ) );
+ 
+ 		if ( ! @copy( $src_file, $dst_file ) )
+ 			$dst_file = false;
+ 	} else {
+ 		$dst_file = false;
+ 	}
+ 
+ 	return $dst_file;
+ }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/import.php ./wordpress-3.4/wp-admin/includes/import.php
*** ./wordpress-3.3.2/wp-admin/includes/import.php	2011-05-22 18:25:28.000000000 -0500
--- ./wordpress-3.4/wp-admin/includes/import.php	2012-01-08 11:01:11.000000000 -0600
***************
*** 93,97 ****
  
  	return array( 'file' => $file, 'id' => $id );
  }
- 
- ?>
--- 93,95 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/list-table.php ./wordpress-3.4/wp-admin/includes/list-table.php
*** ./wordpress-3.3.2/wp-admin/includes/list-table.php	2011-01-16 15:47:24.000000000 -0600
--- ./wordpress-3.4/wp-admin/includes/list-table.php	2012-03-02 16:09:26.000000000 -0600
***************
*** 28,34 ****
  		'WP_Links_List_Table' => 'links',
  		'WP_Plugin_Install_List_Table' => 'plugin-install',
  		'WP_Themes_List_Table' => 'themes',
! 		'WP_Theme_Install_List_Table' => 'theme-install',
  		'WP_Plugins_List_Table' => 'plugins',
  		// Network Admin
  		'WP_MS_Sites_List_Table' => 'ms-sites',
--- 28,34 ----
  		'WP_Links_List_Table' => 'links',
  		'WP_Plugin_Install_List_Table' => 'plugin-install',
  		'WP_Themes_List_Table' => 'themes',
! 		'WP_Theme_Install_List_Table' => array( 'themes', 'theme-install' ),
  		'WP_Plugins_List_Table' => 'plugins',
  		// Network Admin
  		'WP_MS_Sites_List_Table' => 'ms-sites',
***************
*** 37,43 ****
  	);
  
  	if ( isset( $core_classes[ $class ] ) ) {
! 		require_once( ABSPATH . 'wp-admin/includes/class-wp-' . $core_classes[ $class ] . '-list-table.php' );
  		return new $class;
  	}
  
--- 37,44 ----
  	);
  
  	if ( isset( $core_classes[ $class ] ) ) {
! 		foreach ( (array) $core_classes[ $class ] as $required )
! 			require_once( ABSPATH . 'wp-admin/includes/class-wp-' . $required . '-list-table.php' );
  		return new $class;
  	}
  
***************
*** 101,104 ****
  		return $this->_columns;
  	}
  }
- ?>
\ No newline at end of file
--- 102,104 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/manifest.php ./wordpress-3.4/wp-admin/includes/manifest.php
*** ./wordpress-3.3.2/wp-admin/includes/manifest.php	2011-08-03 05:19:00.000000000 -0500
--- ./wordpress-3.4/wp-admin/includes/manifest.php	2012-02-16 22:59:42.000000000 -0600
***************
*** 43,49 ****
  		array('images/wpspin_dark.gif'),
  		array('images/logo.gif'),
  		array('images/logo-ghost.png'),
- 		array('images/logo-login.gif'),
  		array('images/media-button-image.gif'),
  		array('images/media-button-music.gif'),
  		array('images/media-button-other.gif'),
--- 43,48 ----
